diff -ruN vdr-1.7.12/libsi/si.c vdr-1.7.13/libsi/si.c
--- vdr-1.7.12/libsi/si.c	2009-12-05 17:20:12.000000000 +0100
+++ vdr-1.7.13/libsi/si.c	2010-02-13 11:31:52.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.c 2.1 2009/12/05 16:20:12 kls Exp $
+ *   $Id: si.c 2.2 2010/02/13 10:31:52 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -311,6 +311,11 @@
 static const char *SystemCharacterTable = NULL;
 bool SystemCharacterTableIsSingleByte = true;
 
+bool systemCharacterTableIsSingleByte(void)
+{
+  return SystemCharacterTableIsSingleByte;
+}
+
 bool SetSystemCharacterTable(const char *CharacterTable) {
    if (CharacterTable) {
       for (unsigned int i = 0; i < NumEntries(CharacterTables1); i++) {
@@ -335,11 +340,7 @@
    return false;
 }
 
-// Determines the character table used in the given buffer and returns
-// a string indicating that table. If no table can be determined, the
-// default ISO6937 is returned. If a table can be determined, the buffer
-// and length are adjusted accordingly.
-static const char *getCharacterTable(const unsigned char *&buffer, int &length, bool *isSingleByte = NULL) {
+const char *getCharacterTable(const unsigned char *&buffer, int &length, bool *isSingleByte) {
    const char *cs = "ISO6937";
    // Workaround for broadcaster stupidity: according to
    // "ETSI EN 300 468" the default character set is ISO6937. But unfortunately some
@@ -375,7 +376,7 @@
    return cs;
 }
 
-static bool convertCharacterTable(const char *from, size_t fromLength, char *to, size_t toLength, const char *fromCode)
+bool convertCharacterTable(const char *from, size_t fromLength, char *to, size_t toLength, const char *fromCode)
 {
   if (SystemCharacterTable) {
      iconv_t cd = iconv_open(SystemCharacterTable, fromCode);
diff -ruN vdr-1.7.12/libsi/si.h vdr-1.7.13/libsi/si.h
--- vdr-1.7.12/libsi/si.h	2009-12-06 12:37:35.000000000 +0100
+++ vdr-1.7.13/libsi/si.h	2010-02-13 11:31:34.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 2.2 2009/12/06 11:37:35 kls Exp $
+ *   $Id: si.h 2.3 2010/02/13 10:31:34 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -492,6 +492,13 @@
 // like "iso8859-15" or "utf-8" (case insensitive).
 // Returns true if the character table was recognized.
 bool SetSystemCharacterTable(const char *CharacterTable);
+// Determines the character table used in the given buffer and returns
+// a string indicating that table. If no table can be determined, the
+// default ISO6937 is returned. If a table can be determined, the buffer
+// and length are adjusted accordingly.
+const char *getCharacterTable(const unsigned char *&buffer, int &length, bool *isSingleByte = NULL);
+bool convertCharacterTable(const char *from, size_t fromLength, char *to, size_t toLength, const char *fromCode);
+bool systemCharacterTableIsSingleByte(void);
 
 } //end of namespace
 
diff -ruN vdr-1.7.12/menu.c vdr-1.7.13/menu.c
--- vdr-1.7.12/menu.c	2010-01-31 13:43:24.000000000 +0100
+++ vdr-1.7.13/menu.c	2010-02-21 15:09:19.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.14 2010/01/31 12:43:24 kls Exp $
+ * $Id: menu.c 2.17 2010/02/21 14:09:19 kls Exp $
  */
 
 #include "menu.h"
@@ -24,6 +24,7 @@
 #include "recording.h"
 #include "remote.h"
 #include "shutdown.h"
+#include "sourceparams.h"
 #include "sources.h"
 #include "status.h"
 #include "themes.h"
@@ -189,6 +190,7 @@
 private:
   cChannel *channel;
   cChannel data;
+  cSourceParam *sourceParam;
   char name[256];
   void Setup(void);
 public:
@@ -200,6 +202,7 @@
 :cOsdMenu(tr("Edit channel"), 16)
 {
   channel = Channel;
+  sourceParam = NULL;
   if (channel) {
      data = *channel;
      if (New) {
@@ -215,8 +218,6 @@
 void cMenuEditChannel::Setup(void)
 {
   int current = Current();
-  char type = **cSource::ToString(data.source);
-#define ST(s) if (strchr(s, type))
 
   Clear();
 
@@ -242,18 +243,13 @@
   Add(new cMenuEditIntItem( tr("Rid"),          &data.rid, 0));
   XXX*/
   // Parameters for specific types of sources:
-  ST(" S ")  Add(new cMenuEditChrItem( tr("Polarization"), &data.polarization, "hvlr"));
-  ST(" S ")  Add(new cMenuEditMapItem( tr("System"),       &data.system,       SystemValues));
-  ST("CS ")  Add(new cMenuEditIntItem( tr("Srate"),        &data.srate));
-  ST("CST")  Add(new cMenuEditMapItem( tr("Inversion"),    &data.inversion,    InversionValues));
-  ST("CST")  Add(new cMenuEditMapItem( tr("CoderateH"),    &data.coderateH,    CoderateValues));
-  ST("  T")  Add(new cMenuEditMapItem( tr("CoderateL"),    &data.coderateL,    CoderateValues));
-  ST("CST")  Add(new cMenuEditMapItem( tr("Modulation"),   &data.modulation,   ModulationValues));
-  ST("  T")  Add(new cMenuEditMapItem( tr("Bandwidth"),    &data.bandwidth,    BandwidthValues));
-  ST("  T")  Add(new cMenuEditMapItem( tr("Transmission"), &data.transmission, TransmissionValues));
-  ST("  T")  Add(new cMenuEditMapItem( tr("Guard"),        &data.guard,        GuardValues));
-  ST("  T")  Add(new cMenuEditMapItem( tr("Hierarchy"),    &data.hierarchy,    HierarchyValues));
-  ST(" S ")  Add(new cMenuEditMapItem( tr("Rolloff"),      &data.rollOff,      RollOffValues));
+  sourceParam = SourceParams.Get(**cSource::ToString(data.source));
+  if (sourceParam) {
+     sourceParam->SetData(&data);
+     cOsdItem *Item;
+     while ((Item = sourceParam->GetOsdItem()) != NULL)
+           Add(Item);
+     }
 
   SetCurrent(Get(current));
   Display();
@@ -266,6 +262,8 @@
 
   if (state == osUnknown) {
      if (Key == kOk) {
+        if (sourceParam)
+           sourceParam->GetData(&data);
         if (Channels.HasUniqueChannelID(&data, channel)) {
            data.name = strcpyrealloc(data.name, name);
            if (channel) {
@@ -289,8 +287,11 @@
            }
         }
      }
-  if (Key != kNone && (data.source & cSource::st_Mask) != (oldSource & cSource::st_Mask))
+  if (Key != kNone && (data.source & cSource::st_Mask) != (oldSource & cSource::st_Mask)) {
+     if (sourceParam)
+        sourceParam->GetData(&data);
      Setup();
+     }
   return state;
 }
 
@@ -1044,6 +1045,11 @@
      strftime(buffer, sizeof(buffer), "%Y%m%d", &tm_r);
      day = buffer;
      }
+  const char *File = strrchr(timer->File(), FOLDERDELIMCHAR);
+  if (File)
+     File++;
+  else
+     File = timer->File();
   SetText(cString::sprintf("%c\t%d\t%s%s%s\t%02d:%02d\t%02d:%02d\t%s",
                     !(timer->HasFlags(tfActive)) ? ' ' : timer->FirstDay() ? '!' : timer->Recording() ? '#' : '>',
                     timer->Channel()->Number(),
@@ -1054,7 +1060,7 @@
                     timer->Start() % 100,
                     timer->Stop() / 100,
                     timer->Stop() % 100,
-                    timer->File()));
+                    File));
 }
 
 // --- cMenuTimers -----------------------------------------------------------
@@ -1781,22 +1787,6 @@
 
 // --- cMenuCommands ---------------------------------------------------------
 
-class cMenuCommands : public cOsdMenu {
-private:
-  cList<cNestedItem> *commands;
-  cString parameters;
-  cString title;
-  cString command;
-  bool confirm;
-  char *result;
-  bool Parse(const char *s);
-  eOSState Execute(void);
-public:
-  cMenuCommands(const char *Title, cList<cNestedItem> *Commands, const char *Parameters = NULL);
-  virtual ~cMenuCommands();
-  virtual eOSState ProcessKey(eKeys Key);
-  };
-
 cMenuCommands::cMenuCommands(const char *Title, cList<cNestedItem> *Commands, const char *Parameters)
 :cOsdMenu(Title)
 {
diff -ruN vdr-1.7.12/menu.h vdr-1.7.13/menu.h
--- vdr-1.7.12/menu.h	2010-01-17 12:21:42.000000000 +0100
+++ vdr-1.7.13/menu.h	2010-02-06 11:17:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 2.1 2010/01/17 11:21:42 kls Exp $
+ * $Id: menu.h 2.2 2010/02/06 10:17:24 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -53,6 +53,22 @@
   virtual eOSState ProcessKey(eKeys Key);
   };
 
+class cMenuCommands : public cOsdMenu {
+private:
+  cList<cNestedItem> *commands;
+  cString parameters;
+  cString title;
+  cString command;
+  bool confirm;
+  char *result;
+  bool Parse(const char *s);
+  eOSState Execute(void);
+public:
+  cMenuCommands(const char *Title, cList<cNestedItem> *Commands, const char *Parameters = NULL);
+  virtual ~cMenuCommands();
+  virtual eOSState ProcessKey(eKeys Key);
+  };
+
 class cMenuEditTimer : public cOsdMenu {
 private:
   cTimer *timer;
diff -ruN vdr-1.7.12/menuitems.c vdr-1.7.13/menuitems.c
--- vdr-1.7.12/menuitems.c	2009-12-06 12:31:20.000000000 +0100
+++ vdr-1.7.13/menuitems.c	2010-02-16 15:44:35.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 2.5 2009/12/06 11:31:20 kls Exp $
+ * $Id: menuitems.c 2.6 2010/02/16 14:44:35 kls Exp $
  */
 
 #include "menuitems.h"
@@ -1007,7 +1007,7 @@
 
 // --- cMenuEditMapItem ------------------------------------------------------
 
-cMenuEditMapItem::cMenuEditMapItem(const char *Name, int *Value, const tChannelParameterMap *Map, const char *ZeroString)
+cMenuEditMapItem::cMenuEditMapItem(const char *Name, int *Value, const tDvbParameterMap *Map, const char *ZeroString)
 :cMenuEditItem(Name)
 {
   value = Value;
diff -ruN vdr-1.7.12/menuitems.h vdr-1.7.13/menuitems.h
--- vdr-1.7.12/menuitems.h	2009-05-03 14:50:34.000000000 +0200
+++ vdr-1.7.13/menuitems.h	2010-02-21 14:58:21.000000000 +0100
@@ -4,13 +4,14 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 2.2 2009/05/03 12:50:34 kls Exp $
+ * $Id: menuitems.h 2.3 2010/02/21 13:58:21 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
 #define __MENUITEMS_H
 
 #include <limits.h>
+#include "dvbdevice.h"
 #include "osdbase.h"
 
 extern const char *FileNameChars;
@@ -175,11 +176,11 @@
 class cMenuEditMapItem : public cMenuEditItem {
 protected:
   int *value;
-  const tChannelParameterMap *map;
+  const tDvbParameterMap *map;
   const char *zeroString;
   virtual void Set(void);
 public:
-  cMenuEditMapItem(const char *Name, int *Value, const tChannelParameterMap *Map, const char *ZeroString = NULL);
+  cMenuEditMapItem(const char *Name, int *Value, const tDvbParameterMap *Map, const char *ZeroString = NULL);
   virtual eOSState ProcessKey(eKeys Key);
   };
 
diff -ruN vdr-1.7.12/newplugin vdr-1.7.13/newplugin
--- vdr-1.7.12/newplugin	2009-12-06 16:31:58.000000000 +0100
+++ vdr-1.7.13/newplugin	2010-02-06 15:50:03.000000000 +0100
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 2.1 2009/12/06 15:31:58 kls Exp $
+# $Id: newplugin 2.2 2010/02/06 14:50:03 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -77,7 +77,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -85,6 +85,10 @@
 LIBDIR = ../../lib
 TMPDIR = /tmp
 
+### Make sure that necessary options are included:
+
+include \$(VDRDIR)/Make.global
+
 ### Allow user defined options to overwrite defaults:
 
 -include \$(VDRDIR)/Make.config
@@ -104,8 +108,6 @@
 
 DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"\$(PLUGIN)"'
 
-DEFINES += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
-
 ### The object files (add further files here):
 
 OBJS = \$(PLUGIN).o
diff -ruN vdr-1.7.12/nit.c vdr-1.7.13/nit.c
--- vdr-1.7.12/nit.c	2009-12-06 12:36:16.000000000 +0100
+++ vdr-1.7.13/nit.c	2010-02-16 16:37:05.000000000 +0100
@@ -4,12 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: nit.c 2.4 2009/12/06 11:36:16 kls Exp $
+ * $Id: nit.c 2.5 2010/02/16 15:37:05 kls Exp $
  */
 
 #include "nit.h"
 #include <linux/dvb/frontend.h>
 #include "channels.h"
+#include "dvbdevice.h"
 #include "eitscan.h"
 #include "libsi/section.h"
 #include "libsi/descriptor.h"
@@ -124,21 +125,22 @@
           switch (d->getDescriptorTag()) {
             case SI::SatelliteDeliverySystemDescriptorTag: {
                  SI::SatelliteDeliverySystemDescriptor *sd = (SI::SatelliteDeliverySystemDescriptor *)d;
+                 cDvbTransponderParameters dtp;
                  int Source = cSource::FromData(cSource::stSat, BCD2INT(sd->getOrbitalPosition()), sd->getWestEastFlag());
                  int Frequency = Frequencies[0] = BCD2INT(sd->getFrequency()) / 100;
-                 static char Polarizations[] = { 'h', 'v', 'l', 'r' };
-                 char Polarization = Polarizations[sd->getPolarization()];
+                 static char Polarizations[] = { 'H', 'V', 'L', 'R' };
+                 dtp.SetPolarization(Polarizations[sd->getPolarization()]);
                  static int CodeRates[] = { FEC_NONE, FEC_1_2, FEC_2_3, FEC_3_4, FEC_5_6, FEC_7_8, FEC_8_9, FEC_3_5, FEC_4_5, FEC_9_10, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_NONE };
-                 int CodeRate = CodeRates[sd->getFecInner()];
+                 dtp.SetCoderateH(CodeRates[sd->getFecInner()]);
                  static int Modulations[] = { QAM_AUTO, QPSK, PSK_8, QAM_16 };
-                 int Modulation = Modulations[sd->getModulationType()];
-                 int System = sd->getModulationSystem() ? SYS_DVBS2 : SYS_DVBS;
+                 dtp.SetModulation(Modulations[sd->getModulationType()]);
+                 dtp.SetSystem(sd->getModulationSystem() ? SYS_DVBS2 : SYS_DVBS);
                  static int RollOffs[] = { ROLLOFF_35, ROLLOFF_25, ROLLOFF_20, ROLLOFF_AUTO };
-                 int RollOff = sd->getModulationSystem() ? RollOffs[sd->getRollOff()] : ROLLOFF_AUTO;
+                 dtp.SetRollOff(sd->getModulationSystem() ? RollOffs[sd->getRollOff()] : ROLLOFF_AUTO);
                  int SymbolRate = BCD2INT(sd->getSymbolRate()) / 10;
                  if (ThisNIT >= 0) {
                     for (int n = 0; n < NumFrequencies; n++) {
-                        if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], Polarization), Transponder())) {
+                        if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], dtp.Polarization()), Transponder())) {
                            nits[ThisNIT].hasTransponder = true;
                            //printf("has transponder %d\n", Transponder());
                            break;
@@ -152,23 +154,23 @@
                         if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
                            int transponder = Channel->Transponder();
                            found = true;
-                           if (!ISTRANSPONDER(cChannel::Transponder(Frequency, Polarization), transponder)) {
+                           if (!ISTRANSPONDER(cChannel::Transponder(Frequency, dtp.Polarization()), transponder)) {
                               for (int n = 0; n < NumFrequencies; n++) {
-                                  if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], Polarization), transponder)) {
+                                  if (ISTRANSPONDER(cChannel::Transponder(Frequencies[n], dtp.Polarization()), transponder)) {
                                      Frequency = Frequencies[n];
                                      break;
                                      }
                                   }
                               }
-                           if (ISTRANSPONDER(cChannel::Transponder(Frequency, Polarization), Transponder())) // only modify channels if we're actually receiving this transponder
-                              Channel->SetSatTransponderData(Source, Frequency, Polarization, SymbolRate, CodeRate, Modulation, System, RollOff);
+                           if (ISTRANSPONDER(cChannel::Transponder(Frequency, dtp.Polarization()), Transponder())) // only modify channels if we're actually receiving this transponder
+                              Channel->SetTransponderData(Source, Frequency, SymbolRate, dtp.ToString('S'));
                            }
                         }
                     if (!found) {
                        for (int n = 0; n < NumFrequencies; n++) {
                            cChannel *Channel = new cChannel;
                            Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                           if (Channel->SetSatTransponderData(Source, Frequencies[n], Polarization, SymbolRate, CodeRate, Modulation, System, RollOff))
+                           if (Channel->SetTransponderData(Source, Frequencies[n], SymbolRate, dtp.ToString('S')))
                               EITScanner.AddTransponder(Channel);
                            else
                               delete Channel;
@@ -179,13 +181,14 @@
                  break;
             case SI::CableDeliverySystemDescriptorTag: {
                  SI::CableDeliverySystemDescriptor *sd = (SI::CableDeliverySystemDescriptor *)d;
+                 cDvbTransponderParameters dtp;
                  int Source = cSource::FromData(cSource::stCable);
                  int Frequency = Frequencies[0] = BCD2INT(sd->getFrequency()) / 10;
                  //XXX FEC_outer???
                  static int CodeRates[] = { FEC_NONE, FEC_1_2, FEC_2_3, FEC_3_4, FEC_5_6, FEC_7_8, FEC_8_9, FEC_3_5, FEC_4_5, FEC_9_10, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_AUTO, FEC_NONE };
-                 int CodeRate = CodeRates[sd->getFecInner()];
+                 dtp.SetCoderateH(CodeRates[sd->getFecInner()]);
                  static int Modulations[] = { QPSK, QAM_16, QAM_32, QAM_64, QAM_128, QAM_256, QAM_AUTO };
-                 int Modulation = Modulations[min(sd->getModulation(), 6)];
+                 dtp.SetModulation(Modulations[min(sd->getModulation(), 6)]);
                  int SymbolRate = BCD2INT(sd->getSymbolRate()) / 10;
                  if (ThisNIT >= 0) {
                     for (int n = 0; n < NumFrequencies; n++) {
@@ -212,14 +215,14 @@
                                   }
                               }
                            if (ISTRANSPONDER(Frequency / 1000, Transponder())) // only modify channels if we're actually receiving this transponder
-                              Channel->SetCableTransponderData(Source, Frequency, Modulation, SymbolRate, CodeRate);
+                              Channel->SetTransponderData(Source, Frequency, SymbolRate, dtp.ToString('C'));
                            }
                         }
                     if (!found) {
                         for (int n = 0; n < NumFrequencies; n++) {
                            cChannel *Channel = new cChannel;
                            Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                           if (Channel->SetCableTransponderData(Source, Frequencies[n], Modulation, SymbolRate, CodeRate))
+                           if (Channel->SetTransponderData(Source, Frequencies[n], SymbolRate, dtp.ToString('C')))
                               EITScanner.AddTransponder(Channel);
                            else
                               delete Channel;
@@ -230,21 +233,22 @@
                  break;
             case SI::TerrestrialDeliverySystemDescriptorTag: {
                  SI::TerrestrialDeliverySystemDescriptor *sd = (SI::TerrestrialDeliverySystemDescriptor *)d;
+                 cDvbTransponderParameters dtp;
                  int Source = cSource::FromData(cSource::stTerr);
                  int Frequency = Frequencies[0] = sd->getFrequency() * 10;
                  static int Bandwidths[] = { 8000000, 7000000, 6000000, 0, 0, 0, 0, 0 };
-                 int Bandwidth = Bandwidths[sd->getBandwidth()];
+                 dtp.SetBandwidth(Bandwidths[sd->getBandwidth()]);
                  static int Constellations[] = { QPSK, QAM_16, QAM_64, QAM_AUTO };
-                 int Constellation = Constellations[sd->getConstellation()];
+                 dtp.SetModulation(Constellations[sd->getConstellation()]);
                  static int Hierarchies[] = { HIERARCHY_NONE, HIERARCHY_1, HIERARCHY_2, HIERARCHY_4, HIERARCHY_AUTO, HIERARCHY_AUTO, HIERARCHY_AUTO, HIERARCHY_AUTO };
-                 int Hierarchy = Hierarchies[sd->getHierarchy()];
+                 dtp.SetHierarchy(Hierarchies[sd->getHierarchy()]);
                  static int CodeRates[] = { FEC_1_2, FEC_2_3, FEC_3_4, FEC_5_6, FEC_7_8, FEC_AUTO, FEC_AUTO, FEC_AUTO };
-                 int CodeRateHP = CodeRates[sd->getCodeRateHP()];
-                 int CodeRateLP = CodeRates[sd->getCodeRateLP()];
+                 dtp.SetCoderateH(CodeRates[sd->getCodeRateHP()]);
+                 dtp.SetCoderateL(CodeRates[sd->getCodeRateLP()]);
                  static int GuardIntervals[] = { GUARD_INTERVAL_1_32, GUARD_INTERVAL_1_16, GUARD_INTERVAL_1_8, GUARD_INTERVAL_1_4 };
-                 int GuardInterval = GuardIntervals[sd->getGuardInterval()];
+                 dtp.SetGuard(GuardIntervals[sd->getGuardInterval()]);
                  static int TransmissionModes[] = { TRANSMISSION_MODE_2K, TRANSMISSION_MODE_8K, TRANSMISSION_MODE_AUTO, TRANSMISSION_MODE_AUTO };
-                 int TransmissionMode = TransmissionModes[sd->getTransmissionMode()];
+                 dtp.SetTransmission(TransmissionModes[sd->getTransmissionMode()]);
                  if (ThisNIT >= 0) {
                     for (int n = 0; n < NumFrequencies; n++) {
                         if (ISTRANSPONDER(Frequencies[n] / 1000000, Transponder())) {
@@ -270,14 +274,14 @@
                                   }
                               }
                            if (ISTRANSPONDER(Frequency / 1000000, Transponder())) // only modify channels if we're actually receiving this transponder
-                              Channel->SetTerrTransponderData(Source, Frequency, Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode);
+                              Channel->SetTransponderData(Source, Frequency, 0, dtp.ToString('T'));
                            }
                         }
                     if (!found) {
                        for (int n = 0; n < NumFrequencies; n++) {
                            cChannel *Channel = new cChannel;
                            Channel->SetId(ts.getOriginalNetworkId(), ts.getTransportStreamId(), 0, 0);
-                           if (Channel->SetTerrTransponderData(Source, Frequencies[n], Bandwidth, Constellation, Hierarchy, CodeRateHP, CodeRateLP, GuardInterval, TransmissionMode))
+                           if (Channel->SetTransponderData(Source, Frequencies[n], 0, dtp.ToString('T')))
                               EITScanner.AddTransponder(Channel);
                            else
                               delete Channel;
diff -ruN vdr-1.7.12/receiver.c vdr-1.7.13/receiver.c
--- vdr-1.7.12/receiver.c	2010-01-30 11:25:38.000000000 +0100
+++ vdr-1.7.13/receiver.c	2010-02-28 15:25:32.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 2.2 2010/01/30 10:25:38 kls Exp $
+ * $Id: receiver.c 2.3 2010/02/28 14:25:32 kls Exp $
  */
 
 #include "receiver.h"
@@ -81,7 +81,7 @@
      return AddPid(Channel->Vpid()) &&
             (Channel->Ppid() == Channel->Vpid() || AddPid(Channel->Ppid())) &&
             AddPids(Channel->Apids()) &&
-            (!Setup.UseDolbyDigital || AddPids(Channel->Dpids())) &&
+            AddPids(Channel->Dpids()) &&
             AddPids(Channel->Spids());
      }
 return true;
diff -ruN vdr-1.7.12/remux.c vdr-1.7.13/remux.c
--- vdr-1.7.12/remux.c	2010-01-30 11:43:12.000000000 +0100
+++ vdr-1.7.13/remux.c	2010-02-28 15:42:07.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.41 2010/01/30 10:43:12 kls Exp $
+ * $Id: remux.c 2.42 2010/02/28 14:42:07 kls Exp $
  */
 
 #include "remux.h"
@@ -601,7 +601,7 @@
                             dpids[NumDpids] = dpid;
                             dtypes[NumDpids] = stream.getStreamType();
                             strn0cpy(dlangs[NumDpids], lang, sizeof(dlangs[NumDpids]));
-                            if (updatePrimaryDevice)
+                            if (updatePrimaryDevice && Setup.UseDolbyDigital)
                                cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
                             NumDpids++;
                             dpids[NumDpids]= 0;
diff -ruN vdr-1.7.12/runvdr.template vdr-1.7.13/runvdr.template
--- vdr-1.7.12/runvdr.template	2010-01-17 13:39:27.000000000 +0100
+++ vdr-1.7.13/runvdr.template	2010-01-17 13:39:27.000000000 +0100
@@ -20,7 +20,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: runvdr 2.1 2010/01/17 12:39:27 kls Exp $
+# $Id: runvdr.template 2.1 2010/01/17 12:39:27 kls Exp $
 
 VDRPRG="./vdr"
 
diff -ruN vdr-1.7.12/skinclassic.c vdr-1.7.13/skinclassic.c
--- vdr-1.7.12/skinclassic.c	2010-01-03 15:55:10.000000000 +0100
+++ vdr-1.7.13/skinclassic.c	2010-02-13 14:44:48.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 2.3 2010/01/03 14:55:10 kls Exp $
+ * $Id: skinclassic.c 2.4 2010/02/13 13:44:48 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -13,7 +13,9 @@
 #include "osd.h"
 #include "themes.h"
 
-#define ScrollWidth  5
+#define ScrollWidth (Setup.FontOsdSize / 4)
+#define TextFrame   (Setup.FontOsdSize / 10)
+#define TextSpacing (Setup.FontOsdSize / 4)
 
 static cTheme Theme;
 
@@ -94,7 +96,7 @@
   lineHeight = font->Height();
   message = false;
   osd = cOsdProvider::NewOsd(cOsd::OsdLeft(), cOsd::OsdTop() + (Setup.ChannelInfoPos ? 0 : cOsd::OsdHeight() - Lines * lineHeight));
-  timeWidth = font->Width("00:00") + 4;
+  timeWidth = font->Width("00:00") + 2 * TextFrame;
   tArea Areas[] = { { 0, 0, cOsd::OsdWidth() - 1, Lines * lineHeight - 1, 8 } };
   if (Setup.AntiAlias && osd->CanHandleAreas(Areas, sizeof(Areas) / sizeof(tArea)) == oeOk)
      osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
@@ -113,7 +115,7 @@
 void cSkinClassicDisplayChannel::SetChannel(const cChannel *Channel, int Number)
 {
   osd->DrawRectangle(0, 0, osd->Width() - 1, lineHeight - 1, Theme.Color(clrBackground));
-  osd->DrawText(2, 0, ChannelString(Channel, Number), Theme.Color(clrChannelName), Theme.Color(clrBackground), cFont::GetFont(fontOsd));
+  osd->DrawText(TextFrame, 0, ChannelString(Channel, Number), Theme.Color(clrChannelName), Theme.Color(clrBackground), cFont::GetFont(fontOsd));
   lastDate = NULL;
 }
 
@@ -124,9 +126,9 @@
   for (int i = 0; i < 2; i++) {
       const cEvent *e = !i ? Present : Following;
       if (e) {
-         osd->DrawText(             2, (2 * i + 1) * lineHeight, e->GetTimeString(), Theme.Color(clrChannelEpgTimeFg), Theme.Color(clrChannelEpgTimeBg), cFont::GetFont(fontOsd));
-         osd->DrawText(timeWidth + 10, (2 * i + 1) * lineHeight, e->Title(), Theme.Color(clrChannelEpgTitle), Theme.Color(clrBackground), cFont::GetFont(fontOsd));
-         osd->DrawText(timeWidth + 10, (2 * i + 2) * lineHeight, e->ShortText(), Theme.Color(clrChannelEpgShortText), Theme.Color(clrBackground), cFont::GetFont(fontSml));
+         osd->DrawText(                  TextFrame, (2 * i + 1) * lineHeight, e->GetTimeString(), Theme.Color(clrChannelEpgTimeFg), Theme.Color(clrChannelEpgTimeBg), cFont::GetFont(fontOsd));
+         osd->DrawText(timeWidth + 2 * TextSpacing, (2 * i + 1) * lineHeight, e->Title(), Theme.Color(clrChannelEpgTitle), Theme.Color(clrBackground), cFont::GetFont(fontOsd));
+         osd->DrawText(timeWidth + 2 * TextSpacing, (2 * i + 2) * lineHeight, e->ShortText(), Theme.Color(clrChannelEpgShortText), Theme.Color(clrBackground), cFont::GetFont(fontSml));
          }
       }
 }
@@ -152,7 +154,7 @@
      if (!*lastDate || strcmp(date, lastDate)) {
         const cFont *font = cFont::GetFont(fontSml);
         int w = font->Width(date);
-        osd->DrawText(osd->Width() - w - 2, 0, date, Theme.Color(clrChannelDate), Theme.Color(clrBackground), cFont::GetFont(fontSml), w);
+        osd->DrawText(osd->Width() - w - TextFrame, 0, date, Theme.Color(clrChannelDate), Theme.Color(clrBackground), cFont::GetFont(fontSml), w);
         lastDate = date;
         }
      }
@@ -196,7 +198,7 @@
   lineHeight = font->Height();
   dateWidth = 0;
   x0 = 0;
-  x1 = x0 + 10;
+  x1 = x0 + 2 * TextSpacing;
   x3 = cOsd::OsdWidth();
   x2 = x3 - 2 * ScrollWidth;
   y0 = 0;
@@ -440,9 +442,9 @@
   if (!*lastDate || strcmp(date, lastDate)) {
      const cFont *font = cFont::GetFont(fontOsd);
      int w = font->Width(date);
-     osd->DrawText(x3 - w - 2, y0, date, Theme.Color(clrMenuDate), Theme.Color(clrMenuTitleBg), font, w);
+     osd->DrawText(x3 - w - TextFrame, y0, date, Theme.Color(clrMenuDate), Theme.Color(clrMenuTitleBg), font, w);
      lastDate = date;
-     dateWidth = max(w + 2, dateWidth);
+     dateWidth = max(w + TextFrame, dateWidth);
      }
   osd->Flush();
 }
@@ -638,7 +640,7 @@
   int ItemsWidth = font->Width(Title);
   for (int i = 0; i < NumTracks; i++)
       ItemsWidth = max(ItemsWidth, font->Width(Tracks[i]));
-  ItemsWidth += 10;
+  ItemsWidth += 2 * TextSpacing;
   x0 = 0;
   x1 = cOsd::OsdWidth();
   int d = x1 - x0;
